package org.implab.gradle.containers.tasks;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.concurrent.Callable;

import org.gradle.api.provider.ListProperty;
import org.gradle.api.provider.Property;
import org.gradle.api.tasks.Input;
import org.gradle.api.tasks.Optional;
import org.implab.gradle.containers.ImageName;

public abstract class PushImage extends DockerCliTask {

    public final String PUSH_COMMAND = "push";

    @Input
    public abstract Property<ImageName> getImageName();

    @Input
    @Optional
    public abstract Property<String> getTransport();

    @Input
    @Optional
    public abstract ListProperty<String> getOptions();

    public PushImage option(Callable<String> provider) {
        getOptions().add(getProject().provider(provider));
        return this;
    }

    @Override
    protected java.util.Optional<String> getSubCommand() {
        return java.util.Optional.of(PUSH_COMMAND);
    }

    @Override
    protected Collection<String> getSubCommandArguments() {
        List<String> args = new ArrayList<>();

        args.addAll(getOptions().get());
        args.add(getImageName().get().toString());

        return args;
    }
}
